<template>
  <div class="app-container">
    <el-row type="flex" justify="space-between" ref="listQueryContainer" class="query-container">
      <el-col>
        <el-form :inline="true" style="flex-wrap: wrap" :model="listQuery" ref="listQuery" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="添加人姓名" prop="operatingUsername">
            <el-input v-model.trim="listQuery.operatingUsername" maxlength="16" placeholder="请输入添加人姓名" clearable @clear="listQuery.operatingUsername=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="访客姓名" prop="username">
            <el-input v-model.trim="listQuery.username" maxlength="16" placeholder="请输入访客姓名" clearable @clear="listQuery.username=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="访客手机号" prop="userPhone">
            <el-input v-model.trim="listQuery.userPhone" maxlength="16" placeholder="请输入访客手机号" clearable @clear="listQuery.userPhone=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="性别" prop="gender">
            <el-select v-model="listQuery.gender" placeholder="请选择" clearable @clear="listQuery.gender=undefined" @change="onFilterChange">
              <el-option :key="gender.value" :label="gender.label" :value="gender.value" v-for="gender in genderList"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="身份证号" prop="idcard">
            <el-input v-model.trim="listQuery.idcard" maxlength="16" placeholder="请输入身份证号" clearable @clear="listQuery.idcard=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="访客公司" prop="company">
            <el-input v-model.trim="listQuery.company" maxlength="16" placeholder="请输入访客公司" clearable @clear="listQuery.company=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="创建时间范围" prop="createTimeRange">
            <el-date-picker
                v-model="listQuery.createTimeRange"
                value-format="timestamp"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>
          <el-form-item label="更新时间范围" prop="updateTimeRange">
            <el-date-picker
                v-model="listQuery.updateTimeRange"
                value-format="timestamp"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>

          <el-form-item label-width="0">
            <el-button @click="onFilterChange" type="primary">查询</el-button>
            <el-button @click="resetFields" plain type="primary">重置</el-button>
            <el-button @click="onExport" plain type="primary">导出</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @clear="resetFields" @change="onExpansion"/>
    </el-row>

    <el-row>
      <el-button @click="onAdd" type="primary">添加</el-button>
      <el-button v-if="!editing" @click="onBatchDelete" plain type="primary">批量删除</el-button>
      <el-button v-if="editing" @click="onDeleteSelect" type="danger" :disabled="!(selectIds&&selectIds.length)">删除</el-button>
      <el-button v-if="editing" @click="onCancel" plain>取消</el-button>
    </el-row>

    <el-table :data="list" border stripe highlight-current-row ref="table" class="mt10" @sort-change="onSortChange" @selection-change="onTableSelectionChange" @row-click="onRowClick">
      <el-table-column v-if="editing" type="selection" width="55" fixed></el-table-column>
      <el-table-column type="index" :index="indexCompute" label="序号" align="center" fixed="left" width="60px"/>
      <el-table-column prop="username" label="访客姓名" sortable="custom" align="center" min-width="102px"/>
      <el-table-column prop="userPhone" label="访客手机号" sortable="custom" align="center" min-width="116px"/>
      <el-table-column prop="gender" label="性别" sortable="custom" align="center" min-width="74px">
        <template v-slot="scope">
        {{ genderList.find(item => item.value === scope.row.gender).label }}
        </template>
      </el-table-column>
      <el-table-column prop="idcard" label="身份证号" sortable="custom" align="center" min-width="102px"/>
      <el-table-column prop="idcardImage" label="身份证照片" sortable="custom" align="center" min-width="116px">
        <template v-slot="scope">
          <el-image style="height: 40px;" :src="scope.row.idcardImage" contain :preview-src-list="[scope.row.idcardImage]"></el-image>
        </template>
      </el-table-column>
      <el-table-column prop="company" label="访客公司" sortable="custom" align="center" min-width="102px"/>
      <el-table-column prop="remark" label="备注" sortable="custom" align="center" min-width="74px"/>
      <el-table-column prop="validTime" label="有效截止时间" sortable="custom" align="center" width="160px">
        <template v-slot="scope">{{ scope.row.validTime | dateFormat }}</template>
      </el-table-column>
      <el-table-column prop="createTime" label="创建时间" sortable="custom" align="center" width="160px">
        <template v-slot="scope">{{ scope.row.createTime | dateFormat }}</template>
      </el-table-column>
      <el-table-column prop="updateTime" label="更新时间" sortable="custom" align="center" width="160px">
        <template v-slot="scope">{{ scope.row.updateTime | dateFormat }}</template>
      </el-table-column>
      <el-table-column prop="operatingUsername" label="添加人姓名" sortable="custom" align="center" min-width="130px"/>
      <el-table-column label="操作" align="center" min-width="150px">
        <template v-slot="scope">
          <el-link type="primary" icon="el-icon-edit" @click="onUpdate(scope.row)">编辑</el-link>
          <el-link type="primary" icon="el-icon-delete" @click="onDelete(scope.row)" class="ml20">删除</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :total="total" :page.sync="listQuery.page" :size.sync="listQuery.size" @change="onPageChange"/>

    <el-dialog title="导出" :visible.sync="exportVisible" :close-on-click-modal="false" :close-on-press-escape="false" width="600px">
      <el-progress :text-inside="true" :stroke-width="24" :percentage="exportProgress" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>
  </div>
</template>

<script>
import {dateFormat} from "@/utils/dateUtil"

export default {
  name: "VisitorBackup",
  data() {
    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        operatingUsername: undefined, // 添加人姓名
        username: undefined, // 访客姓名
        userPhone: undefined, // 访客手机号
        gender: undefined, // 性别
        idcard: undefined, // 身份证号
        idcardImage: undefined, // 身份证照片
        company: undefined, // 访客公司
        remark: undefined, // 备注
        createTimeRange: [], // 创建时间
        createTimeStart: undefined,
        createTimeEnd: undefined,
        updateTimeRange: [], // 更新时间
        updateTimeStart: undefined,
        updateTimeEnd: undefined,
        order: undefined,
        page: 1,
        size: 10
      },

      list: [], // 结果列表
      total: 0, // 总结果数量

      genderList: [{label: "男", value: 1}, {label: "女", value: 2}],

      exportVisible: false, // 是否显示导出对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      exportCancel: false, // 是否取消导出

      editing: false, // 表格编辑中

      selectItem: undefined, // 选中的单条记录
      selectIds: undefined, // 选中多条记录的id
    }
  },

  watch: {
    'listQuery.createTimeRange'(value) {
      if (value) {
        this.listQuery.createTimeStart = value[0];
        this.listQuery.createTimeEnd = value[1];
      } else {
        this.listQuery.createTimeStart = undefined;
        this.listQuery.createTimeEnd = undefined;
      }
    },
    'listQuery.updateTimeRange'(value) {
      if (value) {
        this.listQuery.updateTimeStart = value[0];
        this.listQuery.updateTimeEnd = value[1];
      } else {
        this.listQuery.updateTimeStart = undefined;
        this.listQuery.updateTimeEnd = undefined;
      }
    },
  },

  // 页面创建
  created() {
    this.initData();
    this.initEvent();
  },

  // 页面挂载
  mounted() {
    this.initView();
    this.initQuery();
    this.getList();
  },

  // keep-alive 显示界面时调用
  activated() {
    this.$refs["table"].doLayout();
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 初始化数据
    initData() {
    },

    // 初始化事件
    initEvent() {
      this.$eventBus.$on("VisitorBackupAdd", this.onAddComplete);
      this.$eventBus.$on("VisitorBackupUpdate", this.onUpdateComplete);
    },

    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order.substring(1), query.order.substring(0, 1) === "+" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 添加
    onAdd() {
      this.onCancel();
      this.selectItem = undefined;
      this.$router.push({path: '/visitor/backup/add'})
    },

    // 编辑
    onBatchDelete() {
      this.editing = true;
    },

    // 删除选中
    onDeleteSelect() {
      this.$confirm('此操作将永久删除选中的记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete("/v1/visitor/backup/delete", {params: {ids: this.selectIds}}).then((data) => {
          if (this.list.length <= this.selectIds.length && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          this.selectIds = undefined;
          if (data) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 取消编辑
    onCancel() {
      this.$refs['table'].clearSelection();
      this.editing = false;
    },

    // 添加完成
    onAddComplete() {
      this.onFilterChange();
    },

    // 更新
    onUpdate(item) {
      this.selectItem = item;
      this.$router.push({path: '/visitor/backup/edit', query: {id: item.id}})
    },

    // 更新完成
    onUpdateComplete() {
      this.onFilterChange();
    },

    // 删除
    onDelete(item) {
      this.$confirm('此操作将永久删除该记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete(`/v1/visitor/backup/delete/${item.id}`).then((data) => {
          if (this.list.length === 1 && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          if (data > 0) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 数据选择
    onTableSelectionChange(val) {
      this.selectIds = val.map(item => item.id);
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
      if (this.editing) {
        this.$refs["table"].toggleRowSelection(row);
      }
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      this.$axios.get("/v1/visitor/backup/list", {params: this.listQuery}).then(data => {
        this.list = data.list;
        this.total = data.total;
        this.$refs["table"].doLayout();
      });
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get("/v1/visitor/backup/list", {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;

            let tHeader = ["序号",
              "访客姓名",
              "访客手机号",
              "性别",
              "身份证号",
              "身份证照片",
              "访客公司",
              "备注",
              "有效截止时间",
              "创建时间",
              "更新时间",
              "添加人姓名",
            ];
            let filterVal = ["index",
              "username",
              "userPhone",
              "gender",
              "idcard",
              "idcardImage",
              "company",
              "remark",
              "validTime",
              "createTime",
              "updateTime",
              "operatingUsername",
            ];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "validTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", value[key]);
              } else if (key === "createTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", value[key]);
              } else if (key === "updateTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", value[key]);
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '备案管理', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.app-container {

}
</style>
